// InpoutTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdio.h"
#include "string.h"
#include "stdlib.h"
#include <windows.h>
/* ----Prototypes of Inp and Outp--- */

short _stdcall Inp32(short PortAddress);
void _stdcall Out32(short PortAddress, short data);

/*--------------------------------*/

int sysclk = 1e9;

unsigned char profiles[] = {0x0a,0x10,0x16,0x1c};

int setData(unsigned char value){
	Out32(0x378,value);
	Out32(0x37a,251);
	Out32(0x37a,250);
	return 0;
}

int setAddress(unsigned char value){
	Out32(0x378,value);
	Out32(0x37a,248);
	Out32(0x37a,250);
	return 0;
}

int setControl(unsigned char value){
	Out32(0x378,value);
	Out32(0x37a,242);
	Out32(0x37a,250);
	return 0;
}



int writeReg(unsigned char address,unsigned char value){
	setAddress(address);
	setControl(68);
	setData(value);
	setControl(100);
	return 0;
}


int toggleFud(){
	setControl(116);
	setControl(100);
	return 0;
}

int startup(){
	setControl(100);
	writeReg(0x00,0x58);
	toggleFud();
	return 0;
}

int setFrequency(unsigned char profile, double frequency){
	unsigned int FTW = frequency * 4294967296 / sysclk;
	writeReg(profiles[profile],(FTW >> 0) & 0xff);
	writeReg(profiles[profile]+1,(FTW >> 8) & 0xff);
	writeReg(profiles[profile]+2,(FTW >> 16) & 0xff);
	writeReg(profiles[profile]+3,(FTW >> 24) & 0xff);
	return 0;
}

int main(int argc, char* argv[])
{
	int tmp = -1;
	startup();
	writeReg(0x01,0x00);
	writeReg(0x02,0x10);
	toggleFud();
	writeReg(0x02,0x00);
	setFrequency(0,130e6);
	toggleFud();
	Sleep(1000);
	while(true){
		writeReg(0x04,0);
		writeReg(0x05,0);
		writeReg(0x06,0);
		writeReg(0x07,0);
		setFrequency(0,130e6);
		writeReg(0x04,1);
		writeReg(0x08,6);	//Fastsweep: 1 , Slowsweep:  6
		writeReg(0x09,0);
		writeReg(0x02,0x10);
		Sleep(950);			//Fastsweep: 167 , Slowsweep:  950
		toggleFud();
		writeReg(0x02,0x00);
		writeReg(0x01,0x80);
		toggleFud();
		writeReg(0x04,0);
		setFrequency(0,134.3e6);
		writeReg(0x02,0x10);
		Sleep(950);			//Fastsweep: 167 , Slowsweep:  950
		toggleFud();
		writeReg(0x04,(tmp >> 0)&0xff);
		writeReg(0x05,(tmp >> 8) & 0xff);
		writeReg(0x06,(tmp >> 16) & 0xff);
		writeReg(0x07,(tmp >> 24) & 0xff);
		writeReg(0x02,0x00);
		toggleFud();
		}
	return 0;
}
