/*
	Software for ATtiny2313 on
	FMCW Synthesizer 9.2GHz board

	by
	Ruben Undheim
	Master thesis 2012 NTNU
*/
#define F_CPU 1000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "ad9858control.h"


int main(void) {
	init();
	//uint32_t verdi = 37796000; // veldig lav

	//uint32_t verdi = 463400000; // 8.2GHz
	//uint32_t verdi = 4.8036e8; // 8.5GHz
	//uint32_t verdi = 4.9731e8; // 8.8GHz
	//uint32_t verdi = 5.1427e8; // 9.1GHz
//	uint32_t verdi = 5.1992e8; // 9.2GHz
	//uint32_t verdi = 5.2274e8; // 9.25GHz
	//uint32_t verdi = 5.2557e8; // 9.3GHz
	//uint32_t verdi = 5.3122e8; // 9.4GHz
	//uint32_t verdi = 536870912; // 9.5GHz
	//uint32_t verdi = 5.4817e8; // 9.7GHz
	//uint32_t verdi = 5.5382e8; // 9.8GHz

	//uint32_t verdi = 5.7643e8; // 10.2GHz
	//uint32_t verdi 	= 519920000; 
	//uint32_t verdi = 3.9559e8; // 7GHz
	//uint32_t verdi = 4.521e8; // 8GHz

	//uint32_t verdi = 7.6401e8; // 9.25
	uint32_t verdi = 5.1992e8; // 9.2GHz
	uint32_t verdi2 = 5.2025e8; 

	//uint32_t verdi = 7.5988e8; // 9.2 
	//uint32_t verdi2 = 7.603e8; 
	uint32_t verdi3 = 7.605e8; 

	delay_ms(500);
	set_bit(CTRL_2GHZ,1);
	toggle_fud();
	write_long(0x05,verdi2); 
	write_long(0x07,verdi3); 
	toggle_fud();
		set_profile(1);
	while(1){
		write_long(0x03,verdi); 
		toggle_fud();
		verdi = verdi + 50000000;
		delay_ms(1000);
	}

}


