h=508e-6;
eps_r = 4.5;
W = [0e-3:0.1e-3:3e-3];



eps_eff=(eps_r+1)./2+(eps_r-1)./(2*sqrt(1+(10.*h./W)));

Zc_2=120*pi./(sqrt(eps_eff).*(W/h+1.393+0.667.*log(W./h+1.444)));

set(gca,'fontsize',32)
plot(W,Zc_2,'LineWidth',5);
axis([0 3e-3 0 100]);
xlabel('mm');
ylabel('Z_0');
print -deps -color -F:32 ../thesis/figur/char_impedance.eps
pause
