/*
	Software for ATtiny2313 on
	FMCW Synthesizer 9.2GHz board

	by
	Ruben Undheim
	Master thesis 2012 NTNU
*/
#define F_CPU 1000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "ad9858control.h"


int main(void) {
	init();
	uint32_t fvalue = 5.1992e8+0.0282e8; // 9.25GHz
	uint32_t fvalue2 = 5.2025e8+0.0282e8; 


	delay_ms(500);
	set_bit(CTRL_2GHZ,1);
	toggle_fud();
	write_long(0x03,fvalue); 
	write_long(0x05,fvalue2); 
	toggle_fud();
	while(1){
		set_profile(1);
		delay_mini(120);
		set_profile(2);
		delay_mini(120);
	}

}


