
f = logspace(2,8,1000);
c = 3e8;

vcox = [10,  100,  1e3,10e3,100e3,1e6, 100e6];
vco = [-20 , -20 , -56,-92,-117,-138,  -180];

vcoi = interp1(10*log10(vcox),vco,10*log10(f),'linear');

L = 10.^(vcoi./10);%0.01./f.^2;%+100000000./f.^3;

l = 0.100;
Lut1 = 4.*L.*(sin(pi.*l.*f./c)).^2;
l = 0.500;
Lut2 = 4.*L.*(sin(pi.*l.*f./c)).^2;
l = 20;
Lut3 = 4.*L.*(sin(pi.*l.*f./c)).^2;
l = 200;
Lut4 = 4.*L.*(sin(pi.*l.*f./c)).^2;
l = 1000;
Lut5 = 4.*L.*(sin(pi.*l.*f./c)).^2;

set(gca,'fontsize',32)

semilogx(f,10*log10(abs(L)),'linewidth',5,f,10*log10(abs(Lut1)),'linewidth',5,...
	f,10*log10(abs(Lut2)),'linewidth',5,f,10*log10(abs(Lut3)),'linewidth',5,...
	f,10*log10(abs(Lut4)),'linewidth',5,f,10*log10(abs(Lut5)),'linewidth',5);
axis([100 1e8 -200 -18]);
legend('Original VCO phase noise','Path difference 0.1 m','0.5 m','20 m','200 m','1000 m');
xlabel('Offset frequency Hz');
ylabel('dBc/Hz');
print -deps -color -F:32 grafer/cancellation.eps




figure(2)
f = logspace(3,6,1000);
load ddstcxofelles.num

vcoi = interp1(10*log10(vcox),vco,10*log10(f),'linear');
Lvco = 10.^(vcoi./10);

measured = interp1(10*log10(ddstcxofelles(:,1)'),ddstcxofelles(:,2)',10*log10(f),'linear');
L = 10.^(measured./10);%0.01./f.^2;%+100000000./f.^3;
semilogx(f,measured);%10*log10(abs(L)))
figure(3)

l = 0.100;
Lut1 = 4.*L.*(sin(pi.*l.*f./c)).^2;
l = 0.500;
Lut2 = 4.*L.*(sin(pi.*l.*f./c)).^2;
l = 20;
Lut3 = 4.*L.*(sin(pi.*l.*f./c)).^2;
l = 200;
Lut4 = 4.*L.*(sin(pi.*l.*f./c)).^2;
l = 1000;
Lut5 = 4.*L.*(sin(pi.*l.*f./c)).^2;

set(gca,'fontsize',32)

semilogx(f,10*log10(abs(L)),'linewidth',5,f,10*log10(abs(Lut1)),'linewidth',5,...
	f,10*log10(abs(Lut2)),'linewidth',5,f,10*log10(abs(Lut3)),'linewidth',5,...
	f,10*log10(abs(Lut4)),'linewidth',5,f,10*log10(abs(Lut5)),'linewidth',5,...
	f,10*log10(abs(Lvco)),'linestyle','--','linewidth',5);
axis([1000 1e6 -205 -60]);
legend('Original synthesizer phase noise','Path difference 0.1 m','0.5 m','20 m','200 m','1000 m','VCO');
xlabel('Offset frequency Hz');
ylabel('dBc/Hz');
print -deps -color -F:32 grafer/cancellation2.eps

