
R1 = 200;
R2 = 33;
nopv = 0.9e-9;
nopi = 2.4e-12;

k = 1.38065e-23;
T = 290;

n1 = 2*4.*k.*T.*R1.*(R2./(R1+R2)).^2
n2 = 2*4.*k.*T.*R2.*(R1./(R1+R2)).^2
n3_1 = nopv.^2
n3_2 = 2.*nopi.^2.*(R1.*R2./(R1+R2).^2)
n3 = n3_1+n3_2

ntot = sqrt(n1+n2+n3);

volt = n3_1./ntot.^2
current = (n3_2)./ntot.^2
motstand = (n1+n2)./ntot.^2

ntot
