wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 29e3*2*pi;
zeta = 0.43;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
antallnull = 4000;
nullnivaa = ones(1,antallnull)*ferror2(1);
plot(t(1:size(t,2)),[nullnivaa ferror2(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror2'];
save -ascii calculatedfeil10ohm470nf.num ut

wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 29e3*2*pi;
zeta = 0.94;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
antallnull = 4000;
nullnivaa = ones(1,antallnull)*ferror2(1);
plot(t(1:size(t,2)),[nullnivaa ferror2(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror2'];
save -ascii calculatedfeil22ohm470nf.num ut

wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 29e3*2*pi;
zeta = 1.42;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
ferror4 = (wstep-(wstep.*cosh(sqrt(zeta.^2-1).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sinh(sqrt(zeta.^2-1).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(zeta.^2-1))))./(2*pi);
antallnull = 4000;
nullnivaa = ones(1,antallnull)*ferror4(1);
plot(t(1:size(t,2)),[nullnivaa ferror4(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror4'];
save -ascii calculatedfeil33ohm470nf.num ut

wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 23.5e3*2*pi;
zeta = 0.24;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
antallnull = 4000;
nullnivaa = ones(1,antallnull)*ferror2(1);
plot(t(1:size(t,2)),[nullnivaa ferror2(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror2'];
save -ascii calculated10ohm470nf.num ut

wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 23.5e3*2*pi;
zeta = 0.53;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
antallnull = 4000;
nullnivaa = ones(1,antallnull)*ferror2(1);
plot(t(1:size(t,2)),[nullnivaa ferror2(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror2'];
save -ascii calculated22ohm470nf.num ut

wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 23.5e3*2*pi;
zeta = 0.80;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
antallnull = 4000;
nullnivaa = ones(1,antallnull)*ferror2(1);
plot(t(1:size(t,2)),[nullnivaa ferror2(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror2'];
save -ascii calculated33ohm470nf.num ut

wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 19.5e3*2*pi;
zeta = 0.292;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
antallnull = 4010;
nullnivaa = ones(1,antallnull)*ferror2(1);
plot(t(1:size(t,2)),[nullnivaa ferror2(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror2'];
save -ascii calculated10ohm680nf.num ut

wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 19.5e3*2*pi;
zeta = 0.643;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
antallnull = 4000;
nullnivaa = ones(1,antallnull)*ferror2(1);
plot(t(1:size(t,2)),[nullnivaa ferror2(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror2'];
save -ascii calculated22ohm680nf.num ut

wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 19.5e3*2*pi;
zeta = 0.964;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
ferror4 = (wstep-(wstep.*cosh(sqrt(zeta.^2-1).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sinh(sqrt(zeta.^2-1).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(zeta.^2-1))))./(2*pi);
antallnull = 4000;
nullnivaa = ones(1,antallnull)*ferror2(1);
plot(t(1:size(t,2)),[nullnivaa ferror2(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror2'];
save -ascii calculated33ohm680nf.num ut


wstep = 100e6/1024 * 2*pi / 32 /4 
wn = 35e3*2*pi;
zeta = 1.15;
t = [0:0.0000001:0.001];
ferror2 = (wstep-(wstep.*cos(sqrt(1-zeta.^2).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sin(sqrt(1-zeta.^2).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(1-zeta.^2))))./(2*pi);
ferror4 = (wstep-(wstep.*cosh(sqrt(zeta.^2-1).*wn.*t).*exp(-zeta.*wn.*t)-...
	wstep.*sinh(sqrt(zeta.^2-1).*wn.*t).*zeta.*exp(-zeta.*wn.*t)./(sqrt(zeta.^2-1))))./(2*pi);
antallnull = 4000;
nullnivaa = ones(1,antallnull)*ferror2(1);
plot(t(1:size(t,2)),[nullnivaa ferror4(1:size(ferror2,2)-antallnull)],'LineWidth',5);
axis([0 0.001 -100 (wstep + 3000)/ (2*pi)])
ylabel('Hz');
ut = [t' ferror4'];
save -ascii calculated60ohm220nf.num ut
