

load ddstcxofelles.num
load ddsvcofelles.num
load vcotcxofelles.num
load passende.num
load calculated.num
load calculated2.num

set(gca,'fontsize',32)
semilogx(ddstcxofelles(:,1),ddstcxofelles(:,2),'linewidth',3,ddsvcofelles(:,1),ddsvcofelles(:,2),'linewidth',3,vcotcxofelles(:,1),vcotcxofelles(:,2),'linewidth',3)
xlabel('Hz')
ylabel('dBc/Hz')
legend('DDS and TCXO same supply','DDS and VCO same supply','VCO and TCXO same supply')
legend('location','Southwest')
print -color -deps -F:32 measuredphasenoise.eps

set(gca,'fontsize',32)
semilogx(ddstcxofelles(:,1),ddstcxofelles(:,2),'linewidth',3)
xlabel('Hz')
ylabel('dBc/Hz')
print -color -deps -F:32 measuredphasenoise2.eps

set(gca,'fontsize',32)
semilogx(ddstcxofelles(:,1),ddstcxofelles(:,2),'linewidth',3,passende(:,1),passende(:,2),'linewidth',5)
xlabel('Hz')
ylabel('dBc/Hz')
print -color -deps -F:32 measuredphasenoise3.eps

set(gca,'fontsize',32)
semilogx(ddstcxofelles(:,1),ddstcxofelles(:,2),'linewidth',3,calculated(:,1),calculated(:,2),'linewidth',5,calculated2(:,1),calculated2(:,2),'linewidth',5)
xlabel('Hz')
ylabel('dBc/Hz')
legend('Measured phase noise','Calculated phase noise','Calculated phase noise with wrong f_n and \zeta')
legend('location','southeast');
print -color -deps -F:32 measuredphasenoise4.eps
