

load num10c470.num
load num10.num
load num22c470.num
load num33c470.num
load num33nr2.num
load calculated10ohm470nf.num
load calculated22ohm470nf.num
load calculated33ohm470nf.num
load calculated10ohm680nf.num
load calculated60ohm220nf.num

n = [1:size(num10)];
x = [0:(0.00099984/12498):0.00099984];
figure(1)
subplot(2,2,1)
%set(gca,'fontsize',20)
plot(x,num10c470,'linewidth',3);
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,2)
%set(gca,'fontsize',20)
plot(x,num22c470,'linewidth',3)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,3)
%set(gca,'fontsize',20)
plot(x,num33c470,'linewidth',3)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
%subplot(2,2,4)
%set(gca,'fontsize',20)
%plot(x,num10,'linewidth',3)
%xlabel('s');
%axis([0.0001 0.0006 -4e6 6e6])
print -deps -color -F:20 respons.eps


n = [1:size(num10)];
x = [0:(0.00099984/12498):0.00099984];

figure(2)
subplot(2,2,1)
%set(gca,'fontsize',20)
antallnuller = 2680;
plot(x,num10c470,'linewidth',3,calculated10ohm470nf(:,1),[zeros(antallnuller,1) ; calculated10ohm470nf(1:size(calculated10ohm470nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,2)
%set(gca,'fontsize',20)
antallnuller = 2720;
%plot(x,num22c470,'linewidth',3)
plot(x,num22c470,'linewidth',3,calculated22ohm470nf(:,1),[zeros(antallnuller,1) ; calculated22ohm470nf(1:size(calculated22ohm470nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,3)
%set(gca,'fontsize',20)
plot(x,num33c470,'linewidth',3,calculated33ohm470nf(:,1),[zeros(antallnuller,1) ; calculated33ohm470nf(1:size(calculated33ohm470nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
%subplot(2,2,4)
%set(gca,'fontsize',20)
%plot(x,num10,'linewidth',3,calculated10ohm680nf(:,1),[zeros(antallnuller,1) ; calculated10ohm680nf(1:size(calculated10ohm680nf,1)-antallnuller,2)*7680]-2735000,'linewidth',3)
%xlabel('s');
%axis([0.0001 0.0006 -3e6 7e6])
print -deps -color -F:20 respons2.eps

figure(3)
load e60ohm.num
%set(gca,'fontsize',20)
plot(x,e60ohm,'linewidth',3,calculated60ohm220nf(:,1),[zeros(antallnuller,1) ; calculated60ohm220nf(1:size(calculated60ohm220nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
figure(4)
load e60ohmutenfilter.num
%set(gca,'fontsize',20)
antallnuller = 2760;
plot(x,e60ohmutenfilter,'linewidth',3,calculated60ohm220nf(:,1),[zeros(antallnuller,1) ; calculated60ohm220nf(1:size(calculated60ohm220nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
figure(5)

%set(gca,'fontsize',20)
antallnuller = 2760;
load e10ohm.num
antallnuller = 2720;
plot(x,e10ohm,'linewidth',3,calculated10ohm680nf(:,1),[zeros(antallnuller,1) ; calculated10ohm680nf(1:size(calculated10ohm680nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])

load e22ohm.num
load e33ohm.num
load calculated22ohm680nf.num
load calculated33ohm680nf.num
antallnuller = 2720;
figure(6)
subplot(2,2,1)
%set(gca,'fontsize',20)
antallnuller = 2680;
plot(x,e10ohm,'linewidth',3,calculated10ohm680nf(:,1),[zeros(antallnuller,1) ; calculated10ohm680nf(1:size(calculated10ohm680nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,2)
%set(gca,'fontsize',20)
antallnuller = 2720;
%plot(x,num22c470,'linewidth',3)
plot(x,e22ohm,'linewidth',3,calculated22ohm680nf(:,1),[zeros(antallnuller,1) ; calculated22ohm680nf(1:size(calculated22ohm680nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,3)
%set(gca,'fontsize',20)
plot(x,e33ohm,'linewidth',3,calculated33ohm680nf(:,1),[zeros(antallnuller,1) ; calculated33ohm680nf(1:size(calculated33ohm680nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
%subplot(2,2,4)
%set(gca,'fontsize',20)
%plot(x,num10,'linewidth',3,calculated10ohm680nf(:,1),[zeros(antallnuller,1) ; calculated10ohm680nf(1:size(calculated10ohm680nf,1)-antallnuller,2)*7680]-2735000,'linewidth',3)
%xlabel('s');
%axis([0.0001 0.0006 -3e6 7e6])
print -deps -color -F:20 respons3.eps

load e10ohmutenfilter.num
load e22ohmutenfilter.num
load e33ohmutenfilter.num
antallnuller = 2720;
figure(7)
subplot(2,2,1)
%set(gca,'fontsize',20)
antallnuller = 2680;
plot(x,e10ohmutenfilter,'linewidth',3,calculated10ohm680nf(:,1),[zeros(antallnuller,1) ; calculated10ohm680nf(1:size(calculated10ohm680nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,2)
%set(gca,'fontsize',20)
antallnuller = 2720;
%plot(x,num22c470,'linewidth',3)
plot(x,e22ohmutenfilter,'linewidth',3,calculated22ohm680nf(:,1),[zeros(antallnuller,1) ; calculated22ohm680nf(1:size(calculated22ohm680nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,3)
%set(gca,'fontsize',20)
plot(x,e33ohmutenfilter,'linewidth',3,calculated33ohm680nf(:,1),[zeros(antallnuller,1) ; calculated33ohm680nf(1:size(calculated33ohm680nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
%subplot(2,2,4)
%set(gca,'fontsize',20)
%plot(x,num10,'linewidth',3,calculated10ohm680nf(:,1),[zeros(antallnuller,1) ; calculated10ohm680nf(1:size(calculated10ohm680nf,1)-antallnuller,2)*7680]-2735000,'linewidth',3)
%xlabel('s');
%axis([0.0001 0.0006 -3e6 7e6])
print -deps -color -F:20 respons4.eps

figure(8)
subplot(2,2,1)
%set(gca,'fontsize',20)
plot(x,e10ohm,'linewidth',3);
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,2)
%set(gca,'fontsize',20)
plot(x,e22ohm,'linewidth',3)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,3)
%set(gca,'fontsize',20)
plot(x,e33ohm,'linewidth',3)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
print -deps -color -F:20 respons5.eps

figure(9)
load calculatedfeil10ohm470nf.num
load calculatedfeil22ohm470nf.num
load calculatedfeil33ohm470nf.num

subplot(2,2,1)
%set(gca,'fontsize',20)
antallnuller = 2680;
plot(x,num10c470,'linewidth',3,calculatedfeil10ohm470nf(:,1),[zeros(antallnuller,1) ; calculatedfeil10ohm470nf(1:size(calculatedfeil10ohm470nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,2)
%set(gca,'fontsize',20)
antallnuller = 2720;
%plot(x,num22c470,'linewidth',3)
plot(x,num22c470,'linewidth',3,calculatedfeil22ohm470nf(:,1),[zeros(antallnuller,1) ; calculatedfeil22ohm470nf(1:size(calculatedfeil22ohm470nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,3)
%set(gca,'fontsize',20)
plot(x,num33c470,'linewidth',3,calculatedfeil33ohm470nf(:,1),[zeros(antallnuller,1) ; calculatedfeil33ohm470nf(1:size(calculatedfeil33ohm470nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
%subplot(2,2,4)
%set(gca,'fontsize',20)
%plot(x,num10,'linewidth',3,calculated10ohm680nf(:,1),[zeros(antallnuller,1) ; calculated10ohm680nf(1:size(calculated10ohm680nf,1)-antallnuller,2)*7680]-2735000,'linewidth',3)
%xlabel('s');
%axis([0.0001 0.0006 -3e6 7e6])
print -deps -color -F:20 respons6.eps

figure(10)

subplot(2,2,1)
antallnuller = 2680;
plot(x,num10c470,'linewidth',3,calculated10ohm470nf(:,1),[zeros(antallnuller,1) ; calculated10ohm470nf(1:size(calculated10ohm470nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,2)
%set(gca,'fontsize',20)
antallnuller = 2720;
%plot(x,num22c470,'linewidth',3)
plot(x,num22c470,'linewidth',3,calculated22ohm470nf(:,1),[zeros(antallnuller,1) ; calculated22ohm470nf(1:size(calculated22ohm470nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,3)
%set(gca,'fontsize',20)
antallnuller = 2680;
plot(x,e10ohm,'linewidth',3,calculated10ohm680nf(:,1),[zeros(antallnuller,1) ; calculated10ohm680nf(1:size(calculated10ohm680nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
subplot(2,2,4)
%set(gca,'fontsize',20)
antallnuller = 2720;
%plot(x,num22c470,'linewidth',3)
plot(x,e22ohm,'linewidth',3,calculated22ohm680nf(:,1),[zeros(antallnuller,1) ; calculated22ohm680nf(1:size(calculated22ohm680nf,1)-antallnuller,2)*7680]-3535000,'linewidth',5)
xlabel('time (s)');
axis([0.0001 0.0006 -4e6 6e6])
print -deps -color -F:20 respons7.eps

pause

