
figure(1)
set(gca,'fontsize',32)
load vftxwith18ohm.num 
spec = vftxwith18ohm;
plot(spec(:,1)/1.0e3,spec(:,2),'LineWidth',3)
xlabel('GHz')
ylabel('dBm')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90 0])
print -color -deps -F:32 vftxwith18ohm.eps

figure(2)
set(gca,'fontsize',32)
load vftxwith22ohm.num
spec = vftxwith22ohm;
plot(spec(:,1)/1.0e3,spec(:,2),'LineWidth',3)
xlabel('GHz')
ylabel('dBm')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90 0])
print -color -deps -F:32 vftxwith22ohm.eps


figure(3)
set(gca,'fontsize',32)
load vftxwith33ohm.num
spec = vftxwith33ohm;
plot(spec(:,1)/1.0e3,spec(:,2),'LineWidth',3)
xlabel('GHz')
ylabel('dBm')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90 0])
print -color -deps -F:32 vftxwith33ohm.eps

figure(4)
set(gca,'fontsize',32)
load vftxwith47ohm.num
spec = vftxwith47ohm;
plot(spec(:,1)/1.0e3,spec(:,2),'LineWidth',3)
xlabel('GHz')
ylabel('dBm')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90 0])
print -color -deps -F:32 vftxwith47ohm.eps

figure(5)
set(gca,'fontsize',32)
load vftxwith62ohm.num
spec = vftxwith62ohm;
plot(spec(:,1)/1.0e3,spec(:,2),'LineWidth',3)
xlabel('GHz')
ylabel('dBm')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90 0])
print -color -deps -F:32 vftxwith62ohm.eps

figure(6)
set(gca,'fontsize',32)
load vftxwith10ohm.num
spec = vftxwith10ohm;
plot(spec(:,1)/1.0e3,spec(:,2),'LineWidth',3)
xlabel('GHz')
ylabel('dBm')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90 0])
print -color -deps -F:32 vftxwith10ohm.eps
figure(7)
set(gca,'fontsize',32)
load vftxwith10ohm470nf.num
spec = vftxwith10ohm470nf;
plot(spec(:,1)/1.0e3,spec(:,2),'LineWidth',3)
xlabel('GHz')
ylabel('dBm')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90 0])
print -color -deps -F:32 vftxwith10ohm470nf.eps
figure(7)
set(gca,'fontsize',32)
load vftxwith22ohm470nf.num
spec = vftxwith22ohm470nf;
plot(spec(:,1)/1.0e3,spec(:,2),'LineWidth',3)
xlabel('GHz')
ylabel('dBm')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90 0])
print -color -deps -F:32 vftxwith22ohm470nf.eps
figure(7)
set(gca,'fontsize',32)
load vftxwith33ohm470nf.num
spec = vftxwith33ohm470nf;
plot(spec(:,1)/1.0e3,spec(:,2),'LineWidth',3)
xlabel('GHz')
ylabel('dBm')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90 0])
print -color -deps -F:32 vftxwith33ohm470nf.eps

juster = 10.13+11.66

plot(vftxwith10ohm(:,1)/1.0e3,vftxwith10ohm(:,2)-juster,'LineWidth',3,vftxwith18ohm(:,1)/1.0e3,vftxwith18ohm(:,2)-juster,'LineWidth',3,vftxwith22ohm(:,1)/1.0e3,vftxwith22ohm(:,2)-juster,'LineWidth',3,vftxwith33ohm(:,1)/1.0e3,vftxwith33ohm(:,2)-juster,'LineWidth',3,vftxwith47ohm(:,1)/1.0e3,vftxwith47ohm(:,2)-juster,'LineWidth',3,vftxwith62ohm(:,1)/1.0e3,vftxwith62ohm(:,2)-juster,'LineWidth',3)
xlabel('GHz')
ylabel('dBc/Hz')
axis([(vftxwith33ohm(1,1)./1.0e3) (vftxwith33ohm(size(vftxwith33ohm,1),1)./1.0e3) -90-juster 0-juster])
legend('R = 10 \Omega','18 \Omega','22 \Omega','33 \Omega','47 \Omega','62 \Omega')
legend('location','south')
axis([vftxwith10ohm(1,1)./1.0e3 vftxwith10ohm(size(vftxwith10ohm,1),1)/1.0e3 -110 -75])
print -color -deps -F:32 vftxwithalle.eps

plot(vftxwith22ohm(:,1)/1.0e3,vftxwith22ohm(:,2)-juster,'LineWidth',3,vftxwith22ohm470nf(:,1)/1.0e3,vftxwith22ohm470nf(:,2)-juster,'LineWidth',3);
xlabel('GHz')
ylabel('dBc/Hz')
title('R = 22 \Omega');
axis([(vftxwith33ohm(1,1)./1.0e3) (vftxwith33ohm(size(vftxwith33ohm,1),1)./1.0e3) -110 -75])
legend('C = 680 nF','470 nF')
print -color -deps -F:32 vftxwithallekond.eps

plot(vftxwith10ohm(:,1)/1.0e3,vftxwith10ohm(:,2)-juster,'LineWidth',3,vftxwith10ohm470nf(:,1)/1.0e3,vftxwith10ohm470nf(:,2)-juster,'LineWidth',3);
xlabel('GHz')
ylabel('dBc/Hz')
title('R = 10 \Omega');
axis([(vftxwith33ohm(1,1)./1.0e3) (vftxwith33ohm(size(vftxwith33ohm,1),1)./1.0e3) -110 -75])
legend('C = 680 nF','470 nF')
print -color -deps -F:32 vftxwithallekond2.eps

plot(vftxwith33ohm(:,1)/1.0e3,vftxwith33ohm(:,2)-juster,'LineWidth',3,vftxwith33ohm470nf(:,1)/1.0e3,vftxwith33ohm470nf(:,2)-juster,'LineWidth',3);
xlabel('GHz')
ylabel('dBc/Hz')
title('R = 10 \Omega');
axis([(vftxwith33ohm(1,1)./1.0e3) (vftxwith33ohm(size(vftxwith33ohm,1),1)./1.0e3) -90-juster 0-juster])
legend('C = 680 nF','470 nF')
print -color -deps -F:32 vftxwithallekond3.eps

figure(6)
set(gca,'fontsize',32)
load withps.num
load withbattery.num
load anritsu_at9250.num
load batterywithvcoown.num
load bedreforsyning.num
spec = withps;
%plot(anritsu_at9250(:,1)/1.0e3,anritsu_at9250(:,2)-juster,'LineWidth',3,withps(:,1)/1.0e3,withps(:,2)-juster,'LineWidth',3,withbattery(:,1)/1.0e3,withbattery(:,2)-juster,'LineWidth',3,batterywithvcoown(:,1)/1.0e3,batterywithvcoown(:,2)-juster,'LineWidth',3,bedreforsyning(:,1)/1.0e3,bedreforsyning(:,2)-juster,'LineWidth',3)
plot(withps(:,1)/1.0e3,withps(:,2)-juster,'LineWidth',3,withbattery(:,1)/1.0e3,withbattery(:,2)-juster,'LineWidth',3,batterywithvcoown(:,1)/1.0e3,batterywithvcoown(:,2)-juster,'LineWidth',3,bedreforsyning(:,1)/1.0e3,bedreforsyning(:,2)-juster,'LineWidth',3)
xlabel('GHz')
ylabel('dBc/Hz')
axis([(spec(1,1)./1.0e3) (spec(size(spec,1),1)./1.0e3) -90-juster -70])
%legend('Anritsu Signal Generator','With Power Supply','On battery','Separate VCO/DDS Supply','Better Supply Cables')
legend('With Power Supply','On battery','Separate VCO/DDS Supply','Better Supply Cables')
print -color -deps -F:32 trygetbetter.eps
